/* $Id: compiler.h,v 1.5 2000/11/27 20:09:44 malekith Exp $ */

#include "class.h"
#include "op.h"
#include <setjmp.h>

enum {
	kind_norm,
	kind_ctor,
	kind_dtor,
};


struct compiler_state {
	struct dbuf *code;
	struct phash *vars;
	jmp_buf croak;
	int sp;
	int dont_emit;
	int break_id;
	struct func_def *f;
	int kind;
	
	/* reloc info : */
	int id;			/* to be used */
	struct dbuf *resolved;		/* u32* */
	struct dbuf *reloc;		/* u32* */
	struct dbuf *class_xrefs;	/* u32* */

	/* strings: */
	struct dbuf *strings, *strings_ids;
};

#define CTX struct compiler_state

void croak(CTX *ctx) __attribute__ ((noreturn));

#define check_align(db) (assert((db_off(db)&(ALIGN-1))==0))
#define RES ((u32*)db_data(ctx->resolved))
#define resolve(a) 				\
	do {					\
		RES[a] = db_off(ctx->code);	\
		if (debug)			\
			printf("id:%d:\n", a);	\
	} while (0)
#define add_u32(x, y) 				\
	do {					\
		check_align(ctx->x);		\
		*(u32*)db_alloc(ctx->x, 4) = y;	\
	} while (0)
	

int add_id(struct compiler_state *ctx);
void add_ref(struct compiler_state *ctx, int op, int id);
void push_string(struct compiler_state *ctx, const char *s);
struct var *find_var(CTX *ctx, const char *name, const char *xclass,
		     struct class_def *c, struct token *t);
int compile_func(struct token *t);

void emit(CTX *ctx, ...);
