/* $Id: lex.l,v 1.7 2000/11/27 20:09:44 malekith Exp $ */
%{
#define YYSTYPE	struct token *
extern YYSTYPE yylval;
#include "y.tab.h"
#include "config.h"
#include "token.h"
#define TOK_NEW(a, b) new_token(0, 0, a, b)
int cpp_get(void);
#define YY_INPUT(buf,result,max_size) 			\
	do {						\
		int c;					\
		if ((c = cpp_get()) == -1)		\
			result = YY_NULL; 		\
		else {					\
			buf[0] = c;			\
			result = 1;			\
		}					\
	} while (0)
%}

	int lineno = 1;

%option noyywrap
%%

[0-9]+	{
	yylval = TOK_NEW(sel_int, atoi(yytext));
	return TOK_NUM;
}

[0-9]+"."[0-9]*(e[+-]?[0-9]+)?	{
	yylval = TOK_NEW(sel_double, atof(yytext));
	return TOK_NUM;
}

"'"."'" {
	yylval = TOK_NEW(sel_int, yytext[1]);
	return TOK_NUM;
}

"\""(\\[n\"\\te]|[^"\\])*"\""	{
	yylval = TOK_NEW(sel_string, yytext);
	return TOK_STRING;
}

class	{ yylval = 0; return TOK_KW_CLASS; }
ptr	{ yylval = 0; return TOK_KW_PTR; }
int	{ yylval = 0; return TOK_KW_INT; }
float	{ yylval = 0; return TOK_KW_FLOAT; }
string	{ yylval = 0; return TOK_KW_STRING; }
proc:	{ yylval = 0; return TOK_KW_PROC; }
if	{ yylval = 0; return TOK_KW_IF; }
else	{ yylval = 0; return TOK_KW_ELSE; }
while	{ yylval = 0; return TOK_KW_WHILE; }
do	{ yylval = 0; return TOK_KW_DO; }
for	{ yylval = 0; return TOK_KW_FOR; }
void	{ yylval = 0; return TOK_KW_VOID; }
new	{ yylval = 0; return TOK_KW_NEW; }
delete	{ yylval = 0; return TOK_KW_DELETE; }
return	{ yylval = 0; return TOK_KW_RETURN; }
null	{ yylval = 0; return TOK_KW_NULL; }

[A-Za-z_][a-zA-Z0-9_]* {
	yylval = TOK_NEW(sel_id, yytext);
	return TOK_ID;
}

"+="	{ yylval = 0; return TOK_EPLUS; }
"-="	{ yylval = 0; return TOK_EMINUS; }
"*="	{ yylval = 0; return TOK_ESTAR; }
"/="	{ yylval = 0; return TOK_ESLASH; }
"%="	{ yylval = 0; return TOK_EPERC; }
"^="	{ yylval = 0; return TOK_EXOR; }
"|="	{ yylval = 0; return TOK_EOR; }
"&="	{ yylval = 0; return TOK_EAND; }
"||"	{ yylval = 0; return TOK_2_OR; }
"&&"	{ yylval = 0; return TOK_2_AND; }
"^^"	{ yylval = 0; return TOK_2_XOR; }
">>"	{ yylval = 0; return TOK_SR; }
"<<"	{ yylval = 0; return TOK_SL; }
"--"	{ yylval = 0; return TOK_2_MINUS; }
"++"	{ yylval = 0; return TOK_2_PLUS; }
"=="	{ yylval = 0; return TOK_EQ; }
"!="	{ yylval = 0; return TOK_NE; }
">="	{ yylval = 0; return TOK_GE; }
"<="	{ yylval = 0; return TOK_LE; }
"->"	{ yylval = 0; return TOK_ARROW; }
"::"	{ yylval = 0; return TOK_RANGE; }
">>="	{ yylval = 0; return TOK_ESR; }
"<<="	{ yylval = 0; return TOK_ESL; }

"@"|"~"|"!"|"("|")"|","|";"|"+"|"-"|"*"|"/"|"%"|"="|":"|"{"|"}"|"<"|">"|"|"	{ yylval = 0; return *yytext; }

[ \t]

.	{ fprintf(stderr, "%d: Illegal char: '%c'\n", lineno, *yytext); exit(1); }

\n	{ lineno++; }

%%
void dummy_unput_usage()
{
	yyunput(0,0);
}
