/* $Id: type.c,v 1.3 2000/11/27 20:09:44 malekith Exp $ */
#include "class.h"
#include <string.h>

void copy_type(struct var_type *dst, const struct var_type *src)
{
	if (dst == 0)
		return;

	if (src == 0) {
		dst->id = sel_int;
		dst->ptr = 0;
	} else {
		dst->id = src->id;
		dst->ptr = src->ptr;
	}
}

int size_of(struct var_type *t)
{
	switch (t->id) {
	case sel_int:
	case sel_ptr:
		return sizeof(iptr);
	case sel_string:
		return sizeof(char*);
	case sel_double:
		return sizeof(real);
	default:	
		halt();
	}
}

char *name_of(struct var_type *t)
{
	static char buf[50];

	switch (t->id) {
	case sel_int:
		strcpy(buf, "int");
		break;
	case sel_ptr:
		strcpy(buf,"ptr(");
		strncpy(buf+4, t->ptr->name, 40);
		buf[43] = 0;
		strcat(buf,")");
		break;
	case sel_string:
		strcpy(buf, "string");
		break;
	case sel_double:
		strcpy(buf, "float");
		break;
	case sel_void:
		strcpy(buf, "void");
		break;
	default:	
		halt();
	}
	
	return buf;
}

int token2type(struct var_type *v, struct token *t)
{
	assert(t->sel == sel_kw);
	v->ptr = 0;
	
	switch (t->v_int) {
	case TOK_KW_INT:
		v->id = sel_int;
		break;
	case TOK_KW_STRING:
		v->id = sel_string;
		break;
	case TOK_KW_FLOAT:
		v->id = sel_double;
		break;
	case TOK_KW_VOID:
		v->id = sel_void;
		break;
	case TOK_KW_NULL:
		v->id = sel_ptr;
		break;
	case TOK_KW_PTR:
		assert(t->left->sel == sel_id);
		v->id = sel_ptr;
		v->ptr = ph_find(class_hash, t->left->v_string);
		if (v->ptr == 0) {
			oops(t, "ptr referenced class %s undefined",
			     t->left->v_string);
			return -1;
		}
		break;
	default:
		halt();
	}

	return 0;
}

int types_diffrent(struct var_type *p1, struct var_type *p2)
{
	return p1->id != p2->id || p1->ptr != p2->ptr; 
}

int proto_args_diffrent(struct var *p1, struct var *p2)
{
	return !(p1 == 0 && p2 == 0) && 
		(p1 == 0 || p2 == 0 || 
		 types_diffrent(&p1->type, &p2->type) || 
		 proto_args_diffrent(p1->next, p2->next));
}
